#!/bin/bash

# Put your UUID here, and keep it secret!
UUID="{{ uuid|default('00000000-0000-0000-0000-000000000000') }}"
PEERFINDER="{{ peerfinder }}"
NB_PINGS=5
SLEEP=10

[ -z "$1" ] && FAMILY="ipv4" || FAMILY="ipv6"

[ "$FAMILY" = "ipv4" ] && PING="ping" || PING="ping6"

while :
do
    sleep "$SLEEP"
    curl "$PEERFINDER"/target/"$UUID"/"$FAMILY" > /tmp/"$FAMILY" 2> /dev/null
    read -r id ip < /tmp/"$FAMILY"
    # Avoid empty fields
    [ -z "$id" -o -z "$ip" ] && continue
    # Make sure "id" is an integer
    printf "%d" "$id" > /dev/null 2>&1 || continue
    # Parsing ping output, for Linux
    output="$($PING -c "$NB_PINGS" "$ip" | grep -A1 "packets transmitted")"
    echo $output | sed -e 's#^\([0-9]*\) packets transmitted, \([0-9]*\) received, .* rtt min/avg/max/mdev = \(.*\)/\(.*\)/\(.*\)/\(.*\) ms$#\1\t\2\t\3\t\4\t\5\t\6#' > /tmp/"$FAMILY"_tmp
    read sent received minrtt avgrtt maxrtt jitter < /tmp/"$FAMILY"_tmp
    [ -z "$avgrtt" ] && continue
    echo "RTT to target $id ($ip) is $avgrtt"
    curl -d "target=${id}&probes_sent=${sent}&probes_received=${received}&minrtt=${minrtt}&avgrtt=${avgrtt}&maxrtt=${maxrtt}&jitter=${jitter}" "$PEERFINDER"/result/report/"$UUID"
done
